/*
 * data.h
 *
 *  Created on: Feb 26, 2010
 *      Author: qwan
 */

#ifndef TCCP_GLOBAL_H_
#define TCCP_GLOBAL_H_

#include "lib/space.h"
#include <vector>
#include <set>
#include <stack>
#include <sys/time.h>
#include <sys/resource.h>
#include <time.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include "setting.h"

#define BILLION  1000000000L;
#define _MAX 6553500
#define _LIST_UNDEFINED 0

PtsSpace* created, *exsiting;
set<int>* domain;

int* T;
set<int>* S;
long* scale;
long result_count;

int* list_delta_dom;
int* list_delta_comp;
int* list_delta_dom2;
int* list_delta_comp2;

float userTime_prep, sysTime_prep;
float userTime_algo1, sysTime_algo1;
float userTime_algo2, sysTime_algo2;
float userTime_algo3, sysTime_algo3;
float userTime_algo4, sysTime_algo4;
float userTime_algo5, sysTime_algo5;
float userTime_overall, sysTime_overall;

struct rusage myTime_program_start, myTime_prep_end,
		myTime_algo1_end, myTime_algo2_end, myTime_algo3_end,myTime_algo4_end,myTime_algo5_end, myTime_end;

long algo1_profit, algo1_mem;
long algo2_profit, algo2_mem;
long algo3_profit, algo3_mem;

long counter_dom1 = 0;
long counter_dom2 = 0;
long counter_comp1 = 0;
long counter_comp2 = 0;
long counter_con = 0;
long counter_del1 = 0;
long counter_del2 = 0;

long counter_inf_hit = 0;
long counter_ninf_hit = 0;
long counter_total = 0;
double add_error, big_delta;
double profit_greedy0, profit_optimal;

Setting setting;

#endif /* DATA_H_ */
